function gadget:GetInfo()
   return {
      name = "Unit Cannon",
      desc = "Spawns units for unit cannons. Special version for Green Farms Concept.",
	  version = "2.1",
      author = "REVENGE",
      date = "September 21, 2013",
      license = "Public Domain",
      layer = -1,
      enabled = true
   }
end

local SetWatchWeapon		= Script.SetWatchWeapon
local GetUnitTeam			= Spring.GetUnitTeam
local GetUnitDefID			= Spring.GetUnitDefID
local CreateUnit			= Spring.CreateUnit
local GetUnitBuildFacing	= Spring.GetUnitBuildFacing
local GetUnitPosition		= Spring.GetUnitPosition
local GetProjectilePosition = Spring.GetProjectilePosition
local GetProjectileVelocity = Spring.GetProjectileVelocity
local GetUnitWeaponState	= Spring.GetUnitWeaponState
local GetUnitWeaponVectors	= Spring.GetUnitWeaponVectors
local AddUnitImpulse		= Spring.AddUnitImpulse
local SetUnitDirection		= Spring.SetUnitDirection
local SetUnitVelocity		= Spring.SetUnitVelocity
local SetUnitPhysics		= Spring.SetUnitPhysics
local PlaySoundFile			= Spring.PlaySoundFile
local rand					= math.random

local spGetPlayerInfo = Spring.GetPlayerInfo

if (not gadgetHandler:IsSyncedCode()) then
  return false
end

if (not Spring.GetMapOptions().bluestone or Spring.GetMapOptions().bluestone == "0") then
  return false
end

local batshot = WeaponDefNames["armmc_batshot"].id

function gadget:Initialize()
	SetWatchWeapon(batshot, true)
end

--[[function gadget:Explosion(weaponID, px, py, pz, ownerID)
	--Spring.Echo(weaponID, px, py, pz, ownerID)
	if ownerID then
		local defID = GetUnitDefID(ownerID)
		local spawn = rand()
		local spawnID
		if (weaponID == samID and spawn > 0.97) then
			spawnID = CreateUnit("armsam", px, py+20, pz, GetUnitBuildFacing(ownerID), GetUnitTeam(ownerID))
			AddUnitImpulse(spawnID, 0, 5, 0)
		elseif (weaponID == mistID and spawn > 0.94) then
			spawnID = CreateUnit("cormist", px, py+20, pz, GetUnitBuildFacing(ownerID), GetUnitTeam(ownerID))
			AddUnitImpulse(spawnID, 0, 5, 0)
		end
	end
end]]--

function gadget:ProjectileCreated(proID, ownerID, weaponID)
	if ownerID and weaponID == batshot then		
		local ownerTeam = GetUnitTeam(ownerID)
		local px,py,pz = GetProjectilePosition(proID)
		local vx,vy,vz = GetProjectileVelocity(proID)
		launchUnit(ownerID, "armbats", px, py, pz, vx, vy, vz)
		--PlaySoundFile("sounds/boing.wav", 1.5, px, py, pz)
	end
end

function launchUnit(ownerID, unitName, px, py, pz, ix, iy, iz)
	local spawnID = CreateUnit(unitName, px, py, pz, GetUnitBuildFacing(ownerID), GetUnitTeam(ownerID))
	SetUnitDirection(spawnID, ix, iy, iz)
	AddUnitImpulse(spawnID, ix, iy, iz)
	return spawnID
end