local mapinfo = {
	name	= "Green Farms Concept",
	shortname   = "greenfarmsconcept",
	description = "Grow it. Pull it. Light it. Smoke it. Fight for metal, especially on the land bridges and around the central platforms! Explore the mysterious map feature options!",
	author  = "REVENGE",
	version = "V2.2",
	--mapfile = "",
	modtype = 3,
	--depend  = {""},
	replace = {},

	--startpic   = "", --// deprecated
	--StartMusic = "", --// deprecated

	maphardness     = 100,
	notDeformable   = false,
	gravity         = 120,
	tidalStrength   = 25,
	maxMetal        = 8.0,
	extractorRadius = 75,
	voidWater       = false,
	autoShowMetal   = true,

	smf = {
		minheight = -160,
		maxheight = 440,
	},
	
	sound = {
		--// Sets the _reverb_ preset (= echo parameters),
		--// passfilter (the direct sound) is unchanged.
		--//
		--// To get a list of all possible presets check:
		--//   https://github.com/spring/spring/blob/master/rts/System/Sound/EFXPresets.cpp
		--//
		--// Hint:
		--// You can change the preset at runtime via:
		--//   /tset UseEFX [1|0]
		--//   /tset snd_eaxpreset preset_name   (may change to a real cmd in the future)
		--//   /tset snd_filter %gainlf %gainhf  (may    "   "  "  "    "  "   "    "   )
		preset = "default",

		passfilter = {
			--// Note, you likely want to set these
			--// tags due to the fact that they are
			--// _not_ set by `preset`!
			--// So if you want to create a muffled
			--// sound you need to use them.
			gainlf = 1.0,
			gainhf = 1.0,
		},

		reverb = {
			--// Normally you just want use the `preset` tag
			--// but you can use handtweak a preset if wanted
			--// with the following tags.
			--// To know their function & ranges check the
			--// official OpenAL1.1 SDK document.
			
			--density
			--diffusion
			--gain
			--gainhf
			--gainlf
			--decaytime
			--decayhflimit
			--decayhfratio
			--decaylfratio
			--reflectionsgain
			--reflectionsdelay
			--reflectionspan
			--latereverbgain
			--latereverbdelay
			--latereverbpan
			--echotime
			--echodepth
			--modtime
			--moddepth
			--airabsorptiongainhf
			--hfreference
			--lfreference
			--roomrollofffactor
		},
	},

	resources = {
		--grassBladeTex = "",

		--grassShadingTex = "",
		--detailTex = "",
		--specularTex = "",
		--splatDetailTex = "",
		--splatDistrTex = "",
		--skyReflectModTex = "",
		--detailNormalTex = "",
		--lightEmissionTex = "",
	},

	splats = {
		texScales = {0.02, 0.02, 0.02, 0.02},
		texMults  = {1.0, 1.0, 1.0, 1.0},
	},

	atmosphere = {
		minWind      = 1,
		maxWind      = 25,

		fogStart     = 1.0,
		fogEnd       = 1.0,
		--fogColor     = {0.63, 0.74, 0.28},

		sunColor     = {1.0, 1.0, 1.0},
		skyColor     = {0.53, 0.8, 0.98},
		skyDir       = {0.0, 0.0, -1.0},
		skyBox       = "",

		cloudDensity = 0.2,
		cloudColor   = {1.0, 1.0, 1.0},
	},

	grass = {
	},

	lighting = {
		--// dynsun
		sunStartAngle = 0.0,
		sunOrbitTime  = 1440.0,
		sunDir        = {0.5, 1.0, 0.5, 1e9},

		--// unit & ground lighting
		groundAmbientColor  = {0.85, 0.85, 0.85},
		groundDiffuseColor  = {0.85, 0.85, 0.85},
		groundSpecularColor = {0.9, 0.9, 0.9},
		groundShadowDensity = 0.8,
		unitAmbientColor    = {0.8, 0.8, 0.8},
		unitDiffuseColor    = {0.8, 0.8, 0.8},
		unitSpecularColor   = {0.9, 0.9, 0.9},
		unitShadowDensity   = 0.8,
		
		specularExponent    = 10.0,
	},
	
	water = {
		surfaceColor = {0.1, 0.4, 0.8},
		diffuseColor = {0.0, 0.3, 0.7},
		baseColor = {0.0, 0.6, 1.0},
		absorb = {0.7, 0.7, 0.7},
		minColor = {1, 1, 1},
	},

	teams = {
		[0] = {startPos = {x = 800, z = 830}},
		[1] = {startPos = {x = 11264-800, z = 830}},
		[2] = {startPos = {x = 800, z = 11264-830}},
		[3] = {startPos = {x = 11264-800, z = 11264-830}},
		
		[4] = {startPos = {x = 2030, z = 2030}},
		[5] = {startPos = {x = 11264-2030, z = 2030}},
		[6] = {startPos = {x = 2030, z = 11264-2030}},
		[7] = {startPos = {x = 11264-2030, z = 11264-2030}},
		
		[8] = {startPos = {x = 2640, z = 2030}},
		[9] = {startPos = {x = 11264-2640, z = 2030}},
		[10] = {startPos = {x = 2640, z = 11264-2030}},
		[11] = {startPos = {x = 11264-2640, z = 11264-2030}},
		
		[12] = {startPos = {x = 2640, z = 2640}},
		[13] = {startPos = {x = 11264-2640, z = 2640}},
		[14] = {startPos = {x = 2640, z = 11264-2640}},
		[15] = {startPos = {x = 11264-2640, z = 11264-2640}},

		[16] = {startPos = {x = 2030, z = 2640}},
		[17] = {startPos = {x = 11264-2030, z = 2640}},
		[18] = {startPos = {x = 2030, z = 11264-2640}},
		[19] = {startPos = {x = 11264-2030, z = 11264-2640}},
		
		[20] = {startPos = {x = 1290, z = 3850}},
		[21] = {startPos = {x = 11264-1290, z = 3850}},
		[22] = {startPos = {x = 1290, z = 11264-3850}},
		[23] = {startPos = {x = 11264-1290, z = 11264-3850}},
		
		[24] = {startPos = {x = 2750, z = 3850}},
		[25] = {startPos = {x = 11264-2750, z = 3850}},
		[26] = {startPos = {x = 2750, z = 11264-3850}},
		[27] = {startPos = {x = 11264-2750, z = 11264-3850}},

		[28] = {startPos = {x = 1980, z = 4590}},
		[29] = {startPos = {x = 11264-1980, z = 4590}},
		[30] = {startPos = {x = 1980, z = 11264-4590}},
		[31] = {startPos = {x = 11264-1980, z = 11264-4590}},

		[32] = {startPos = {x = 4060, z = 4010}},
		[33] = {startPos = {x = 11264-4060, z = 4010}},
		[34] = {startPos = {x = 4060, z = 11264-4010}},
		[35] = {startPos = {x = 11264-4060, z = 11264-4010}},

		[36] = {startPos = {x = 400, z = 420}},
		[37] = {startPos = {x = 11264-400, z = 420}},
		[38] = {startPos = {x = 400, z = 11264-420}},
		[39] = {startPos = {x = 11264-400, z = 11264-420}},
		
	},

	terrainTypes = {
		[0] = {
			name = "Farmland",
			hardness = 100,
			receiveTracks = true,
			moveSpeeds = {
				tank  = 1.0,
				kbot  = 1.0,
				hover = 1.0,
				ship  = 1.0,
			},
		},
	},

	custom = {
	},
}

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- Helper

local function lowerkeys(ta)
	local fix = {}
	for i,v in pairs(ta) do
		if (type(i) == "string") then
			if (i ~= i:lower()) then
				fix[#fix+1] = i
			end
		end
		if (type(v) == "table") then
			lowerkeys(v)
		end
	end
	
	for i=1,#fix do
		local idx = fix[i]
		ta[idx:lower()] = ta[idx]
		ta[idx] = nil
	end
end

lowerkeys(mapinfo)

-- Map Options

if (Spring and Spring.GetMapOptions) then
	local function tmerge(t1, t2)
		for i,v in pairs(t2) do
			if (type(v) == "table") then
				t1[i] = t1[i] or {}
				tmerge(t1[i], v)
			else
				t1[i] = v
			end
		end
	end

	getfenv()["mapinfo"] = mapinfo
		local files = VFS.DirList("mapconfig/mapinfo/", "*.lua")
		table.sort(files)
		for i=1,#files do
			local newcfg = VFS.Include(files[i])
			if newcfg then
				lowerkeys(newcfg)
				tmerge(mapinfo, newcfg)
			end
		end
	getfenv()["mapinfo"] = nil
end

return mapinfo